#    most of this task is now taken from the standard application

set VERSION "PORGAMRAYS"

#    put some default environment variables before loading common 

set env(ServerAccessVersion) 2

set LinuxDirectory [file join $env(MIDASBASE) Data_Acq bin linux-ppc_4xx]
set DAProgram PorgamRaysExecV1

set env(RDOUThdwre) XPRAYSNUCAM

set MaxChans 128

loadsource  sys.common

set Supported_Modules {}


lappend setuplist [list "Show histogram name translations" "Show_Xlate"]
lappend setuplist [list "Edit histogram translation file"  "edit_xlate"]

lappend actionlist [list "Raw Data Display"  "Dump_Raw_Data"]

set frametitle "MIDAS Data Acquisition Experiment Control (PORGAMRAYS)"

set TSPresent 1
set TSEnable 0
set txEnable 0

set histEnable 1
set HistMode 1

set TestBuffer ""

set Options(Include.PORGAMRAYS) 1

set PorgamRays_GroupBase 1

loadsource sys.DA     ;#  for common data acquisition support

loadsource sys.WWW    ;#   for control via Web services


proc Dump_Raw_Data {} {

   set info "\n"

   execute-command 19 "Getting Raw Data" "11 1" 2
   append data [read-register NetVar.EXEC.Response]

     foreach word $data {
         set word $word
         if {$word == 0xaa5555aa} then {
             append info "\n$word - end of dump\n"
             break
         }
         if {$word == 0x55aaaa55} then {
             append info "\n$word - end of event\n"
             continue
         }
         append info "$word "
     }

   midas-information "$info"
}

proc create_spectra {} {
   global SpectrumServer HistMode EGreport PorgamRays_GroupBase
   global MaxChans

   if {$HistMode == 0} {return}
   
   set-footer "Creating spectra"
   set-busy

   set EGreport_SAVE $EGreport
   set EGreport -1

   Make_Xlate $SpectrumServer

   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $MaxChans :name 'Stat' !new)" } m]
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $MaxChans :name 'Rate' !new)" } m]

   map_spectrum "Stat 0 0 0 6"      ;#  map as group 0 item 0  - shift so only group field used

#   for the data channels

   for {set Ch 0} {$Ch < $MaxChans} {incr Ch} {

      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 4096 :name 'Ch$Ch' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            display-eg-error-report self $m "Attempting to create spectrum Ch$Ch"
            clear-footer
            error $m
         } else {
            map_spectrum  "Ch$Ch [expr $PorgamRays_GroupBase+$Ch] 0 0 0"                ;# map as group =$Ch;  item = 0
            set-footer "Created and mapped Ch$Ch"
         }
   }

   set EGreport $EGreport_SAVE

   clear-busy
   clear-footer
}


proc Stop_Electronics {} {
}

proc Go_Electronics {} {

    write-register NetVar.DACQ.PollTicks 50
}

proc Reset_Electronics {} {
}

